org.apache.ignite.ml.dataset.impl.local

## Class LocalDatasetBuilder<K,V>

- java.lang.Object
- - org.apache.ignite.ml.dataset.impl.local.LocalDatasetBuilder<K,V>

- Type Parameters:
    `K` - Type of a key in `upstream` data.
    `V` - Type of a value in `upstream` data.
  All Implemented Interfaces:
    DatasetBuilder<K,V>

      public class LocalDatasetBuilder<K,V>
      extends Object
      implements DatasetBuilder<K,V>

  A dataset builder that makes `LocalDataset`. Encapsulate logic of building local dataset such as allocation required data structures and initialization of `context` part of partitions.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `LocalDatasetBuilder(Map<K,V> upstreamMap, IgniteBiPredicate<K,V> filter, int partitions)` Constructs a new instance of local dataset builder that makes `LocalDataset`.
    `LocalDatasetBuilder(Map<K,V> upstreamMap, IgniteBiPredicate<K,V> filter, int partitions, UpstreamTransformerBuilder upstreamTransformerBuilder)` Constructs a new instance of local dataset builder that makes `LocalDataset`.
    `LocalDatasetBuilder(Map<K,V> upstreamMap, int partitions)` Constructs a new instance of local dataset builder that makes `LocalDataset` with default predicate that passes all upstream entries to dataset.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `<C extends Serializable,D extends AutoCloseable> LocalDataset<C,D>` | `build(LearningEnvironmentBuilder envBuilder, PartitionContextBuilder<K,V,C> partCtxBuilder, PartitionDataBuilder<K,V,C,D> partDataBuilder, LearningEnvironment learningEnvironment)` Constructs a new instance of `Dataset` that includes allocation required data structures and initialization of `context` part of partitions.
    `DatasetBuilder<K,V>` | `withFilter(IgniteBiPredicate<K,V> filterToAdd)` Returns new instance of DatasetBuilder using conjunction of internal filter and `filterToAdd`.
    `DatasetBuilder<K,V>` | `withUpstreamTransformer(UpstreamTransformerBuilder builder)` Returns new instance of `DatasetBuilder` with new `UpstreamTransformerBuilder` added to chain of upstream transformer builders.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LocalDatasetBuilder

          public LocalDatasetBuilder(Map<K,V> upstreamMap,
                                     int partitions)

      Constructs a new instance of local dataset builder that makes `LocalDataset` with default predicate that passes all upstream entries to dataset.
      Parameters:
        `upstreamMap` - `Map` with upstream data.
        `partitions` - Number of partitions.

    - #### LocalDatasetBuilder

          public LocalDatasetBuilder(Map<K,V> upstreamMap,
                                     IgniteBiPredicate<K,V> filter,
                                     int partitions,
                                     UpstreamTransformerBuilder upstreamTransformerBuilder)

      Constructs a new instance of local dataset builder that makes `LocalDataset`.
      Parameters:
        `upstreamMap` - `Map` with upstream data.
        `filter` - Filter for `upstream` data.
        `partitions` - Number of partitions.
        `upstreamTransformerBuilder` - Builder of upstream transformer.

    - #### LocalDatasetBuilder

          public LocalDatasetBuilder(Map<K,V> upstreamMap,
                                     IgniteBiPredicate<K,V> filter,
                                     int partitions)

      Constructs a new instance of local dataset builder that makes `LocalDataset`.
      Parameters:
        `upstreamMap` - `Map` with upstream data.
        `filter` - Filter for `upstream` data.
        `partitions` - Number of partitions.

  - ### Method Detail

    - #### build

          public <C extends Serializable,D extends AutoCloseable> LocalDataset<C,D> build(LearningEnvironmentBuilder envBuilder,
                                                                                          PartitionContextBuilder<K,V,C> partCtxBuilder,
                                                                                          PartitionDataBuilder<K,V,C,D> partDataBuilder,
                                                                                          LearningEnvironment learningEnvironment)

      Constructs a new instance of `Dataset` that includes allocation required data structures and initialization of `context` part of partitions.
      Specified by:
        `build` in interface `DatasetBuilder<K,V>`
      Type Parameters:
        `C` - Type of a partition `context`.
        `D` - Type of a partition `data`.
      Parameters:
        `envBuilder` - Learning environment builder.
        `partCtxBuilder` - Partition `context` builder.
        `partDataBuilder` - Partition `data` builder.
        `learningEnvironment` - Local learning environment.
      Returns:
        Dataset.

    - #### withUpstreamTransformer

          public DatasetBuilder<K,V> withUpstreamTransformer(UpstreamTransformerBuilder builder)

      Returns new instance of `DatasetBuilder` with new `UpstreamTransformerBuilder` added to chain of upstream transformer builders. When needed, each builder in chain first transformed into `UpstreamTransformer`, those are in turn composed together one after another forming final `UpstreamTransformer`. This transformer is applied to upstream data before it is passed to `PartitionDataBuilder` and `PartitionContextBuilder`. This is needed to allow transformation to upstream data which are agnostic of any changes that happen after. Such transformations may be used for deriving meta-algorithms such as bagging (see `BaggingUpstreamTransformer`).
      Specified by:
        `withUpstreamTransformer` in interface `DatasetBuilder<K,V>`
      Returns:
        Returns new instance of `DatasetBuilder` with new `UpstreamTransformerBuilder` added to chain of upstream transformer builders.

    - #### withFilter

          public DatasetBuilder<K,V> withFilter(IgniteBiPredicate<K,V> filterToAdd)

      Returns new instance of DatasetBuilder using conjunction of internal filter and `filterToAdd`.
      Specified by:
        `withFilter` in interface `DatasetBuilder<K,V>`
      Parameters:
        `filterToAdd` - Additional filter.

2022 Copyright © Apache Software Foundation
| Follow @ApacheIgnite
Ignite Database and Caching Platform | : ver. 2.12.0
Release Date | : January 10 2022